# -*- coding: utf-8 -*-
"""
Created on Fri Feb 10 08:32:18 2017

@author: delerue
"""

__author__ = 'delerue'

from ttk import Frame, Label, Scale, Style
from Tkinter import *
from PIL import ImageTk, Image
import time
import glob
import os
import subprocess
import urllib2

#from motor_function import *

global basedir
global FILE_STOP
global FILE_PAUSE
global data_directory
global code_directory

from clio_constants import *

INSERTED_VALUE1=5500000
INSERTED_VALUE2=5000000

threshold_recent=   20
threshold_old=      100

ImagesDisplaySize=(400,300)
N_IMAGES_LINES=2
N_IMAGES_COLS=3
N_IMAGES=N_IMAGES_LINES*N_IMAGES_COLS

PROCESSES_REFRESH_INTERVAL=10

imageNames=[]
for iimage in range(N_IMAGES):
    imageNames.append(code_directory+"no_data.png")
    
URI='http://'+IP_POWER_IP+'/Set.cmd'
auth_handler=urllib2.HTTPBasicAuthHandler()
auth_handler.add_password(realm='IP9258',uri=URI,user='admin',passwd='12345678')
opener= urllib2.build_opener(auth_handler)
urllib2.install_opener(opener)

#This is used for variables that are not updated on each refresh cycle

class MainWindow(Frame):

    def __init__(self, parent):
        Frame.__init__(self, parent)


        self.parent = parent
        self.parent.bind("q",self.onExitKey)
        self.initUI()


    def initUI(self):

    #----------------        
        self.terminate=0
        self.refresh_loop=0
        # canvas for image
        self.canvas = Canvas(self.parent, width=800, height=800)
        self.frameImages = Frame(self.parent, borderwidth=10)
        self.frameImages.grid(row=1, column=0)
        self.my_images=[]
        self.imageLabel=[]
        self.newImage=[]        
        for iline in range(N_IMAGES_LINES):
            for icol in range(N_IMAGES_COLS):
                iimage=iline*N_IMAGES_COLS+icol
                self.my_images.append(ImageTk.PhotoImage(Image.open(imageNames[iimage]).resize(ImagesDisplaySize, Image.ANTIALIAS)))
                self.imageLabel.append(Label(self.frameImages,image=self.my_images[iimage]))
                self.imageLabel[iimage].grid(row=iline,column=icol)

        #Control buttons
        self.frameAllControls = Frame(self.parent, borderwidth=10)
        self.frameAllControls.grid(row=0, column=0)  

        #data status
        self.frameStatus = Frame(self.frameAllControls, borderwidth=10, relief=SUNKEN)
        self.frameStatus.pack(side=LEFT)
        self.clock = Label(self.frameStatus, font=('times', 18, 'bold'), bg='blue')
        self.clock.pack(side=TOP)
        self.latestFileAcquired = Label(self.frameStatus, font=('times', 14, 'bold'), bg='blue')
        self.latestFileAcquired.pack(side=TOP)
        self.latestFileProcessed = Label(self.frameStatus, font=('times', 14, 'bold'), bg='blue')
        self.latestFileProcessed.pack(side=TOP)
        self.latestFileWithSignal = Label(self.frameStatus, font=('times', 14, 'bold'), bg='blue')
        self.latestFileWithSignal.pack(side=TOP)

        #data acquisition
        self.frameAcquisition = Frame(self.frameAllControls, borderwidth=10, relief=SUNKEN)
        self.frameAcquisition.pack(side=LEFT)
        labelAcquisition=Label(self.frameAcquisition,text='Data Acquisition')
        labelAcquisition.grid(row=0,column=0,columnspan=2)
        self.buttonAcqPause = Button(self.frameAcquisition, text="Pause acquisition", command=self.onButtonAcqPause)
        self.buttonAcqPause.grid(row=1,column=0)
        self.buttonAcqStop = Button(self.frameAcquisition, text="Stop acquisition", command=self.onButtonAcqStop)
        self.buttonAcqStop.grid(row=2,column=0)
        self.labelAcquisitionStatus=Label(self.frameAcquisition,text='Status: unkown', bg='magenta')
        self.labelAcquisitionStatus.grid(row=3,column=0)
        self.labelAcquisitionRate=Label(self.frameAcquisition,text='Rate: unkown', bg='magenta')
        self.labelAcquisitionRate.grid(row=4,column=0)
        self.labelAcquisitionPause=Label(self.frameAcquisition,text='Pause: unkown', bg='magenta')
        self.labelAcquisitionPause.grid(row=5,column=0)
      
        #Power status
        self.framePower = Frame(self.frameAllControls, borderwidth=10, relief=SUNKEN)
        self.framePower.pack(side=LEFT)
        labelPower=Label(self.framePower,text='IP Power')
        labelPower.grid(row=0,column=0,columnspan=2)
        self.buttonPower=[ Button(self.framePower, text=str(ipower), command= lambda v=ipower: self.onButtonPower(v)) for ipower in range(4) ]
        for ipower in range(4):
            self.buttonPower[ipower].grid(row=ipower+1,column=0)
            #self.buttonPower[ipower].pack(side=BOTTOM)
        self.buttonPower[0].config(text="Camera")
        self.buttonPower[1].config(text="Blinker")
        self.buttonPower[2].config(text="Amplifier")
        self.buttonPower[3].config(text="Wago+Pot")
                    
        #Motor function
        self.frameMotors = Frame(self.frameAllControls, borderwidth=10, relief=SUNKEN)
        self.frameMotors.pack(side=LEFT)
        labelMotors=Label(self.frameMotors,text='Motors Control')
        labelMotors.grid(row=0,column=0,columnspan=4)
        buttonRetractFull = Button(self.frameMotors, text="Retract completely", command=self.onButtonRetract)
        buttonRetractFull.grid(row=1,column=0)
        buttonInsert1 = Button(self.frameMotors, text="Insert to "+str(INSERTED_VALUE1), command=self.onButtonInsert1)
        buttonInsert1.grid(row=2,column=0)
        buttonBackward20k = Button(self.frameMotors, text="Backward 20k", command=self.onButtonBkd20k)
        buttonBackward20k.grid(row=1,column=1)
        buttonBackward100k = Button(self.frameMotors, text="Backward 100k", command=self.onButtonBkd100k)
        buttonBackward100k.grid(row=1,column=2)
        buttonBackward1m = Button(self.frameMotors, text="Backward 1M", command=self.onButtonBkd1m)
        buttonBackward1m.grid(row=1,column=3)
        buttonForward20k = Button(self.frameMotors, text="Forward 20k", command=self.onButtonFwd20k)
        buttonForward20k.grid(row=2,column=1)
        buttonForward100k = Button(self.frameMotors, text="Forward 100k", command=self.onButtonFwd100k)
        buttonForward100k.grid(row=2,column=2)
        buttonForward1m = Button(self.frameMotors, text="Forward 1M", command=self.onButtonFwd1m)
        buttonForward1m.grid(row=2,column=3)
        self.labelPositionStepTitle=Label(self.frameMotors,text='Position (steps):', bg='grey')
        self.labelPositionStepTitle.grid(row=3,column=0,columnspan=1)
        self.labelPositionStep=Label(self.frameMotors,text='Status: unkown', bg='blue')
        self.labelPositionStep.grid(row=3,column=1,columnspan=1)
      
        self.labelPositionCurrentTitle=Label(self.frameMotors,text=' (current):', bg='grey')
        self.labelPositionCurrentTitle.grid(row=3,column=2,columnspan=1)
        self.labelPositionCurrent=Label(self.frameMotors,text='Status: unkown', bg='blue')
        self.labelPositionCurrent.grid(row=3,column=3,columnspan=1)

        
        #Check process status
        self.frameProcesses = Frame(self.frameAllControls, borderwidth=10, relief=SUNKEN)
        self.frameProcesses.pack(side=LEFT)
        self.labelProcessIPPower=Label(self.frameProcesses,text='IP Power', bg='blue')
        self.labelProcessIPPower.grid(row=0,column=0,columnspan=1)
        self.labelProcessWago=Label(self.frameProcesses,text='WAGO', bg='blue')
        self.labelProcessWago.grid(row=1,column=0,columnspan=1)
        self.labelProcessMotorMonitor=Label(self.frameProcesses,text='Motor monitor', bg='blue')
        self.labelProcessMotorMonitor.grid(row=2,column=0,columnspan=1)
        self.labelProcessSaveData=Label(self.frameProcesses,text='Savedata', bg='blue')
        self.labelProcessSaveData.grid(row=3,column=0,columnspan=1)
        self.labelProcessProcessRecent=Label(self.frameProcesses,text='Process recent', bg='blue')
        self.labelProcessProcessRecent.grid(row=4,column=0,columnspan=1)
        
        #Exit
        self.buttonExit = Button(self.frameAllControls, text="Exit", command=self.onExit)
        self.buttonExit.pack(side=LEFT)

        self.update_clock()
        self.motorUpdateErrors=0;
        self.getMotorPosition()


    def update_clock(self):
        self.refresh_loop=self.refresh_loop+1
        now = time.strftime("%d/%m/%Y %H:%M:%S")
        self.clock.config(text=now,bg='green')
        
        list_of_files_acquired = glob.glob(data_directory+"data_CLIO*.txt")
        #print(list_of_files_acquired)
        if (len(list_of_files_acquired)>0):
            latest_file_acquired = max(list_of_files_acquired, key=os.path.getctime)
            filetime=os.path.getctime(latest_file_acquired)
            if (time.time()-filetime)<threshold_recent:
                bgcolortxt='green'
                fgcolortxt='black'
            elif (time.time()-filetime)<threshold_old:
                bgcolortxt='blue'
                fgcolortxt='white'
            else:
                bgcolortxt='red'
                fgcolortxt='black'
            self.latestFileAcquired.config(text=os.path.basename(latest_file_acquired),bg=bgcolortxt,fg=fgcolortxt)

        list_of_files_processed = glob.glob(data_directory+"data_CLIO*.png")
        #print(list_of_files_processed)
        if (len(list_of_files_processed)>0):
            #latest_file_processed = max(list_of_files_processed, key=os.path.getctime)
            latest_file_processed = max(sorted(list_of_files_processed))
            filetime=os.path.getctime(latest_file_processed)
            if (time.time()-filetime)<threshold_recent:
                bgcolortxt='green'
                fgcolortxt='black'
            elif (time.time()-filetime)<threshold_old:
                bgcolortxt='blue'
                fgcolortxt='white'
            else:
                bgcolortxt='red'
                fgcolortxt='black'
            self.latestFileProcessed.config(text=os.path.basename(latest_file_processed),bg=bgcolortxt,fg=fgcolortxt)
            imageNames[0]=latest_file_processed;


        list_of_files_with_signal = glob.glob(data_directory+"data_CLIO*.sig")
        #print(list_of_files_with_signal)
        if (len(list_of_files_with_signal)>0):
            #latest_file_with_signal = max(list_of_files_with_signal, key=os.path.getctime)
            latest_file_with_signal = max(sorted(list_of_files_with_signal))
            filetime=os.path.getctime(latest_file_with_signal)
            if (time.time()-filetime)<threshold_recent:
                bgcolortxt='green'
                fgcolortxt='black'
            elif (time.time()-filetime)<threshold_old:
                bgcolortxt='blue'
                fgcolortxt='white'
            else:
                bgcolortxt='red'
                fgcolortxt='black'
            self.latestFileWithSignal.config(text=os.path.basename(latest_file_with_signal),bg=bgcolortxt,fg=fgcolortxt)

            imageNames[0]=latest_file_with_signal.replace(".sig",".png")
            imageNames[1]=latest_file_with_signal.replace(".sig","_zoom.png")
            imageNames[2]=latest_file_with_signal.replace(".sig","_signal.png")
	    time.sleep(0.1)

            self.newImage=[]
            for iimage in range(N_IMAGES):
	        try:
        	    self.newImage.append(ImageTk.PhotoImage(Image.open(imageNames[iimage]).resize(ImagesDisplaySize, Image.ANTIALIAS)))
                    self.imageLabel[iimage].configure(image=self.newImage[iimage])
                    self.imageLabel[iimage].image=self.newImage[iimage]
	        except:
		    print("An error occurred while opening the image: "+imageNames[iimage]+" image "+str(iimage))
	        time.sleep(0.1)

        
        self.getMotorPosition()
        #Check acquisition status
        stop_file = glob.glob(FILE_STOP)
        pause_file = glob.glob(FILE_PAUSE)
        if (len(stop_file)):
            self.labelAcquisitionStatus.config(text="Stop",bg='red',fg='black')
            self.buttonAcqPause.config(text="Program stopped!")
        elif (len(pause_file)):
            self.labelAcquisitionStatus.config(text="Pause", bg='blue',fg='white')
            self.buttonAcqPause.config(text="Restart")
        else:
            self.labelAcquisitionStatus.config(text="Enabled", bg='green',fg='black')

        #check remote processes
        if (self.refresh_loop%PROCESSES_REFRESH_INTERVAL==1):
            response=os.system("ping -c 1 "+motor_controller_IP)
            if response==0:
                self.labelProcessWago.config(bg='green')
            else:
                self.labelProcessWago.config(bg='red')

        if (self.refresh_loop%PROCESSES_REFRESH_INTERVAL==2):
            filetime=0
            iloop=0
            while ((filetime==0)or((time.time()-filetime)>threshold_old))and(iloop<5):
                if (iloop>0):
                    time.sleep(0.5)
                iloop=iloop+1
                try:
                    filetime=os.path.getctime(motor_position_info)
                except:
                    filetime=0
                    
            if (time.time()-filetime)<threshold_recent:
                bgcolortxt='green'
            elif (time.time()-filetime)<threshold_old:
                bgcolortxt='cyan'
            else:
                bgcolortxt='red'
            self.labelProcessMotorMonitor.config(bg=bgcolortxt)

        if (self.refresh_loop%PROCESSES_REFRESH_INTERVAL==3):
            try:
                response=subprocess.check_output("ps -edf | grep -v grep | grep -c savedata_CLIO",shell=True)
            except:
                response='0' 
            if (response[0]=='1'):
                bgcolortxt='green'
            else:
                bgcolortxt='red'
            self.labelProcessSaveData.config(bg=bgcolortxt)

        if (self.refresh_loop%PROCESSES_REFRESH_INTERVAL==4):
            try:
#                response=subprocess.check_output("ps -edf | grep -v grep | grep -c process_recent_files",shell=True)
                response=subprocess.check_output("ps -edf | grep -v grep | grep -c makefile_recent",shell=True)
            except:
                response='0' 
            if (response[0]=='1'):
                bgcolortxt='green'
            else:
                bgcolortxt='red'
            self.labelProcessProcessRecent.config(bg=bgcolortxt)
                
        self.update_idletasks()
        if self.terminate==0:
        	self.after(500, self.update_clock)

        if (self.refresh_loop%PROCESSES_REFRESH_INTERVAL==5):
            response=os.system("ping -c 1 "+IP_POWER_IP)
            if response==0:
                self.labelProcessIPPower.config(bg='green')
            else:
                self.labelProcessIPPower.config(bg='red')

        if (self.refresh_loop%PROCESSES_REFRESH_INTERVAL==6):
            self.set_power_buttons_color()

        if (self.refresh_loop%PROCESSES_REFRESH_INTERVAL==7):
            fid=open(FILE_ACQ_INFO,'r')
            fileline=fid.readline()
            print fileline
            key_values={}
            while len(fileline)>0:
                print fileline
                entries=fileline.replace('\n','').split(' ')
                key_values[entries[0]]=entries[1]
                fileline=fid.readline()
            fid.close()
            if (key_values['RATE']):
                rate_value=36000./float(key_values['RATE'])
                self.labelAcquisitionRate.config(text='Rate= '+str(rate_value)+'kS/s',bg='white')
            
            if (key_values['PAUSE']):
                self.labelAcquisitionPause.config(text='Wait= '+key_values['PAUSE']+' ms',bg='white')
            
    def getMotorPosition(self):
        if (len(glob.glob(motor_position_info))>0):
            fid=open(motor_position_info,'r')
            fileline=fid.readline()
            key_values={}
            while len(fileline)>0:
                print fileline
                entries=fileline.replace('#','').replace(' ','').replace('\n','').split('=')
                key_values[entries[0]]=entries[1]
                fileline=fid.readline()
            fid.close()
            if key_values['motor_value']:
                self.labelPositionStep.config(text=key_values['motor_value']);
                self.labelPositionStep.config(bg='green',fg='black');
            else:
                self.labelPositionStep.config(bg='red',fg='black');

            if key_values['current_value']:
                self.labelPositionCurrent.config(text=key_values['current_value']);
                self.labelPositionCurrent.config(bg='green',fg='black');
            else:
                self.labelPositionCurrent.config(bg='red',fg='black');
        else:
            self.labelPositionCurrent.config(bg='blue',fg='white');
            self.labelPositionStep.config(bg='blue',fg='white');

    def set_power_buttons_color(self):
        power_request=urllib2.urlopen(URI+'?CMD=GetPower')
        values=power_request.read().replace('<html>','').replace('</html>\r\n','').replace('p6','').split(',')
        #            print repr(values)
        for ipower in range(4):
            print values[ipower].split('=')[1]
            if (values[ipower].split('=')[1]=='1'):
                self.buttonPower[ipower].config(bg='green')
            else:
                self.buttonPower[ipower].config(bg='cyan')        
                
    #----------------
    def onButtonRetract(self):
        print "Move motor Retract"        
        fid=open(motor_position_request,'w')
        fid.write("abs0;\n")
        self.labelPositionCurrent.config(bg='cyan');
        self.labelPositionStep.config(bg='cyan');
        fid.close()

    def onButtonInsert1(self):
        print "Move motor Insert "+str(INSERTED_VALUE1)        
        fid=open(motor_position_request,'w')
        fid.write("abs"+str(INSERTED_VALUE1)+";\n")
        fid.close()
        self.labelPositionCurrent.config(bg='cyan');
        self.labelPositionStep.config(bg='cyan');

    def moveMotor(self,direction,step):
        if ((direction!=0)and(step>0)):
            fid=open(motor_position_request,'w')
            fid.write("rel"+str(direction*step)+";\n")
            fid.close()
        self.labelPositionCurrent.config(bg='cyan');
        self.labelPositionStep.config(bg='cyan');
    
    #----------------
    def onButtonBkd20k(self):
        self.moveMotor(-1,20000)

        #----------------
    def onButtonBkd100k(self):
        self.moveMotor(-1,100000)

    #----------------
    def onButtonBkd1m(self):
        self.moveMotor(-1,1000000)

    #----------------
    def onButtonFwd20k(self):
        self.moveMotor(1,20000)

    #----------------
    def onButtonFwd100k(self):
        self.moveMotor(1,100000)

    #----------------
    def onButtonFwd1m(self):
        self.moveMotor(1,1000000)

    def onButtonPower(self,value):
        print('Power value='+str(value))
        print(repr(self.buttonPower[value].cget("bg")))
        power_state=0
        if (self.buttonPower[value].cget("bg")=='green'):
            power_state=1
        self.buttonPower[value].config(bg='blue')
        power_request=urllib2.urlopen(URI+'?CMD=SetPower+P6'+str(value+1)+'='+str(1-power_state))
        values=power_request.read().replace('<html>','').replace('</html>\r\n','').replace('p6','').split(',')
        self.after(2000, self.set_power_buttons_color)

    #----------------
    def onButtonAcqPause(self):
        pause_file = glob.glob(FILE_PAUSE)
        if (len(pause_file)==0):
            filename=FILE_PAUSE
            fid=open(filename,'w')
            fid.write("pause")
            fid.close()
        else:
            os.remove(FILE_PAUSE)
            self.buttonAcqPause.config(text="Pause")

    #----------------
    def onButtonAcqStop(self):
        filename=FILE_STOP
        fid=open(filename,'w')
        fid.write("stop")
        fid.close()
        
    #----------------
#    def onButton(self):

        # next image
#        self.my_image_number += 1

        # return to first image
#        self.my_image_number = 0

    def onExitKey(self,event):
        print "Exit key"
        self.onExit()

    def onExit(self):
        print "Exit"
        self.terminate=1
        time.sleep(0.2)
        self.quit()
        self.master.destroy()


#----------------------------------------------------------------------

root = Tk()
MainWindow(root)

root.mainloop()
