"""
Sets the constants for the CLIO data acquisition code
March 2017
"""

__author__ = 'delerue'


import glob
import time

global basedir
global FILE_STOP
global FILE_PAUSE
global data_directory
global data_dir
global motor_controller_IP
global motor_controller_port
global write_to_motor_dated_log
global motor_position_info
#global motor_position_save
global motor_position_request
global code_directory

# detecting on which computer the code is running
computer=0
COMPUTER_SP_CLIO=1
COMPUTER_ND_MAC=2

if (len(glob.glob("/home/etalon-admin/"))==1):
    print "Running on SP@CLIO's DAQ computer"
    computer=COMPUTER_SP_CLIO
elif (len(glob.glob("/Users/delerue/"))==1):
    print "Running on Nicolas'Mac"
    computer=COMPUTER_ND_MAC


today_str = time.strftime("%Y%m%d")


# setting the correct directories
if computer==COMPUTER_SP_CLIO:
    basedir="/home/etalon-admin/"
    code_directory=basedir+"control/"
    FILE_PAUSE=basedir+'acquisition_data/pause_acquisition';
    FILE_STOP=basedir+'acquisition_data/stop_acquisition';
    motor_position_info=basedir+'acquisition_data/motor_position.txt';
    motor_position_request=basedir+'acquisition_data/motor_requested_position.txt';
    data_directory_base="/var/www/html/CLIO/"
    FILE_ACQ_INFO=basedir+'acquisition_data/acquisition_info.txt'
#    data_dir="/home/etalon-admin/acquisition_data"    

elif computer==COMPUTER_ND_MAC:
    basedir="/Users/delerue/"
#    data_dir="/home/etalon-admin/acquisition_data"    
    code_directory=basedir+"control/"
    FILE_PAUSE=basedir+'acquisition_data/pause_acquisition';
    FILE_STOP=basedir+'acquisition_data/stop_acquisition';
    motor_position_info=basedir+'acquisition_data/motor_position.txt';
    motor_position_request=basedir+'acquisition_data/motor_requested_position.txt';
#    data_directory_base="/var/www/html/CLIO/"
    data_directory_base='/Users/delerue/Downloads/CLIO_tmp/'
    today_str="20170227"
    FILE_STOP='/Users/delerue/Downloads/CLIO_tmp/20170227/stop_acquisition';

#    data_dir="/home/etalon-admin/acquisition_data"

data_directory=data_directory_base+today_str+"/"


##Scope IPs
#SCOPE1_IP='129.175.202.193'
#SCOPE2_IP='129.175.202.14'

IP_POWER_IP='10.20.60.10'

motor_controller_IP='10.20.60.7'
motor_controller_port=30000

#Cameras [top, upstream, downstream]
CAMERA_1_ON=1
CAMERA_2_ON=0
CAMERAS_ON=[CAMERA_1_ON, CAMERA_2_ON]

CAMERA_1_TYPE=1
CAMERA_2_TYPE=0
CAMERAS_TYPE=[CAMERA_1_TYPE, CAMERA_2_TYPE]


CAMERA_1_PORT='129.175.202.189:80'
CAMERA_2_PORT='129.175.202.190:80'
CAMERAS_PORT=[CAMERA_1_PORT, CAMERA_2_PORT]

write_to_motor_dated_log = data_directory + "clio_write_to_motor_dated_log"
#motor_position_save=data_directory + "motor_position.txt';

data_dir=data_directory
